/*
 * RSP Software
 * 
 * Sample code
 * 
 * Thu Dec 20 22:41:25 2007
 * 
 * http://rspsoftware.bighost.com.br
 * info@rspsoftware.bighost.com.br
 * 
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace encrypt
{
    public partial class Form4 : Form
    {
        public Form4()
        {
            InitializeComponent();
        }

        private void Form4_FormClosing(object sender, FormClosingEventArgs e)
        {
            System.Environment.Exit(0);
        }

        private void Form4_Load(object sender, EventArgs e)
        {
            this.Text = axRSPEncrypt1.ControlName().ToString() + " Sample ";
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string InputString;
            string OutPutString = "";
            string Password;
            int Ret = 0;

            Password = textBox1.Text;
            InputString = textBox2.Text;





            if (checkBox1.CheckState == CheckState.Checked)
            {

                //  'Unicode encryption mode

                if (checkBox3.CheckState == CheckState.Checked)
                {
                    Ret = axRSPEncrypt1.EncryptStringAES_Unicode(InputString, ref OutPutString, Password);
                }

                if (checkBox2.CheckState == CheckState.Checked)
                {
                    Ret = axRSPEncrypt1.EncryptStringAES_Unicode_CTR(InputString, ref OutPutString, Password);
                }

                if (checkBox4.CheckState == CheckState.Checked)
                {
                    Ret = axRSPEncrypt1.EncryptStringRC4_Unicode(InputString, ref OutPutString, Password);
                }

            }
            else
            {

                //  'Normal encryption mode
                if (checkBox3.CheckState == CheckState.Checked)
                {
                    Ret = axRSPEncrypt1.EncryptStringAES(InputString, ref OutPutString, Password);
                }

                if (checkBox2.CheckState == CheckState.Checked)
                {
                    Ret = axRSPEncrypt1.EncryptStringAES_CTR(InputString, ref OutPutString, Password);
                }

                if (checkBox4.CheckState == CheckState.Checked)
                {
                    Ret = axRSPEncrypt1.EncryptStringRC4(InputString, ref OutPutString, Password);
                }

            }


            //    'To avoid the problems related to the limitations of TextBoxes in VB
            if (OutPutString.Length > 65535)
            {
                MessageBox.Show("textboxes cannot show strings larger than 65536 characters , instead use RichTextBoxes");
                return;
            }

            textBox3.Text = OutPutString;

            if (Ret > 0)
            {
                MessageBox.Show("Error encrypting string: " + Ret.ToString());
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            string InputString = "";
            string OutPutString = "";
            string Password = "";
            int Ret = 0;

            Password = textBox1.Text;
            InputString = textBox3.Text;


            if (checkBox1.CheckState == CheckState.Checked)
            {

                //  'Unicode encryption mode

                if (checkBox3.CheckState == CheckState.Checked)
                {
                    Ret = axRSPEncrypt1.DecryptStringAES_Unicode(InputString, ref OutPutString, Password);
                }

                if (checkBox2.CheckState == CheckState.Checked)
                {
                    Ret = axRSPEncrypt1.DecryptStringAES_Unicode_CTR(InputString, ref OutPutString, Password);
                }

                if (checkBox4.CheckState == CheckState.Checked)
                {
                    Ret = axRSPEncrypt1.DecryptStringRC4_Unicode(InputString, ref OutPutString, Password);
                }

            }
            else
            {

                //  'Normal encryption mode
                if (checkBox3.CheckState == CheckState.Checked)
                {
                    Ret = axRSPEncrypt1.DecryptStringAES(InputString, ref OutPutString, Password);
                }

                if (checkBox2.CheckState == CheckState.Checked)
                {
                    Ret = axRSPEncrypt1.DecryptStringAES_CTR(InputString, ref OutPutString, Password);
                }

                if (checkBox4.CheckState == CheckState.Checked)
                {
                    Ret = axRSPEncrypt1.DecryptStringRC4(InputString, ref OutPutString, Password);
                }

            }


            textBox4.Text = OutPutString;

            if (Ret > 0)
            {
                MessageBox.Show("Error decrypting string: " + Ret.ToString());
            }


            if (textBox4.Text != textBox2.Text)
            {

                MessageBox.Show("The inputstring isnot the same as the input string");

            }

        }

        private void checkBox2_MouseUp(object sender, MouseEventArgs e)
        {
            checkBox4.CheckState = CheckState.Unchecked;
            checkBox3.CheckState = CheckState.Unchecked;
            checkBox2.CheckState = CheckState.Checked;
        }

        private void checkBox3_MouseUp(object sender, MouseEventArgs e)
        {
            checkBox4.CheckState = CheckState.Unchecked;
            checkBox2.CheckState = CheckState.Unchecked;
            checkBox3.CheckState = CheckState.Checked;
        }

        private void checkBox4_MouseUp(object sender, MouseEventArgs e)
        {
            checkBox2.CheckState = CheckState.Unchecked;
            checkBox3.CheckState = CheckState.Unchecked;
            checkBox4.CheckState = CheckState.Checked;
        }
    }
}
